uniform float Factor;
uniform float Exposure;
uniform float Gamma;

uniform sampler2D Tex0;
uniform sampler2D Tex1;

void main(void)
{
	vec4 colorMap = texture2D(Tex0, gl_TexCoord[0].st);
	vec4 bloomMap = texture2D(Tex1, gl_TexCoord[0].st);

	gl_FragColor = colorMap + Factor * (bloomMap - colorMap);

//	vec2 inTex = gl_TexCoord[0].st - 0.5;
//	float vignette = 1.0 - dot(inTex, inTex);
//	gl_FragColor *= pow(vignette, 4.0);

	gl_FragColor *= Exposure;
	gl_FragColor = pow(gl_FragColor, vec4(Gamma));
}
