uniform float Exposure;
uniform float Threshold;

uniform sampler2D Tex0;
uniform sampler2D Tex1;

const vec3 LUMINANCE = vec3(0.299, 0.587, 0.114);

void main(void)
{
	float lum, scaleLum;

	vec4 color = texture2D(Tex0, gl_TexCoord[0].st);
	vec4 lc = texture2D(Tex1, vec2(0.5, 0.5));

	lum = dot(color.rgb, LUMINANCE);

	scaleLum = (lum * Exposure) / lc.r;
	color.rgb *= (scaleLum * (1.0 + (scaleLum / (lc.g * lc.g)))) / (1.0 + scaleLum);
	color.rgb -= Threshold;
	color.rgb = max(color.rgb, 0.0);

	gl_FragColor = color;
}
