#ifndef CLASS_STRING_TEX
#define CLASS_STRING_TEX

#include <stdexcept>
#include <string>
#include <vector>
#include "VertexBuffer.h"
#include "Texture.h"

struct Glyph
{
	int w;
	int h;
};


/// A class for string drawing from a TTF font
class StringTex
{
	protected:
		GLfloat *_vertices;
		GLfloat *_texcoords;
		GLuint *_indices;
		VertexBuffer _vbo;
		std::vector<Texture *> _tex;
		struct Glyph *_glyphs;
		int _line_skip;

		/// Setup the VBOs data for a single character
		void SetupVBOChar(int idx);
	public:
		/// Default constructor
		StringTex(const std::string& filename, int size=24) throw(std::invalid_argument);
		/// Destructor
		~StringTex();
		/// Draw a string
		void Draw(const std::string& text);
		/// Get the line skip
		int LineSkip() { return _line_skip; };
};

#endif

